global zc

struct ZorbConsole
(
	class="ZorbConsole",
	title="default",
	enableLog = true,
	verboseLevel = 4,
	logData = #(),
	OrgFilterOn=true,
	OrgFilterStr="User",
	OrgFilterInv=true,
	RO_ZorbConsole=
	Rollout RO_ZorbConsole ("Zorb Log Console v1.01: "+this.title)
	(
		local parent = undefined
		fn initLisView lv =
		(
		--lv.gridlines = true
		lv.View = (dotNetClass "System.Windows.Forms.View").Details
		lv.fullRowSelect = true
		lv.hideSelection = false
		lv.Columns.add "Origin" (260)
		lv.Columns.add "Information" (760)
		lv.Columns.add "Time" (145)			
		)
		fn CloseMe = (try (destroydialog parent.RO_ZorbConsole) catch ())
		dotNetControl LV_Console "System.Windows.Forms.ListView" height:240 width:1190 align:#center
		Label LA_Enable "Enable Data Logging:" align:#Left
		CheckBox CB_Enable "" align:#Left offset:[105,-18]
		Label LA_Level "Verbosity Level:" align:#Left offset:[135,-20]
		Dropdownlist DD_Level "" items:#("0 (General)", "1 (Fatal Error)", "2 (Error)", "3 (Warning)", "4 (Information)", "5 (Verbose)") align:#Left width: 80 offset:[215,-21]
		Label LA_OrgFilter "Origin Filter:" align:#Left offset:[310,-24]
		Edittext ET_OrgFilter width: 280 align:#Left offset:[370,-19]
		checkbutton CK_OrgFilterInv "I" align:#Left offset:[650,-21] tooltip:"Invert Filter" width:12 height:16
		Checkbox CB_OrgFilterOn "" align:#Left offset:[663,-21] tooltip:"Apply Filter"
		Button BT_Clear "Clear Log Data" align:#Right offset:[7,-23]
		on RO_ZorbConsole open do
		(
			initLisView LV_Console
		)
		on RO_ZorbConsole close do
		(
			parent.AddLog #("User", "Log Closed", 0)
		)
		on RO_ZorbConsole resized size do
		(
			if parent.RO_ZorbConsole.width < 600 then parent.RO_ZorbConsole.width = 600
			if parent.RO_ZorbConsole.height < 85 then parent.RO_ZorbConsole.height = 85
			LV_Console.width = parent.RO_ZorbConsole.width-10
			LV_Console.height = parent.RO_ZorbConsole.height-12-20
			LV_Console.columns.item[1].width = (parent.RO_ZorbConsole.width-10 - LV_Console.columns.item[0].width - LV_Console.columns.item[2].width - 25)
			LA_Enable.pos.y = (LV_Console.height + 10)
			CB_Enable.pos.y = (LV_Console.height + 10)
			LA_Level.pos.y = (LV_Console.height + 10)
			DD_Level.pos.y = (LV_Console.height + 7)
			BT_Clear.pos.y = (LV_Console.height + 7)
			LA_OrgFilter.pos.y = (LV_Console.height + 10)
			ET_OrgFilter.pos.y = (LV_Console.height + 9)
			CK_OrgFilterInv.pos.y = (LV_Console.height + 10)
			CB_OrgFilterOn.pos.y = (LV_Console.height + 10)
			BT_Clear.pos.x = (LV_Console.width + -83)
			if LV_Console.Items.Count != 0 then LV_Console.EnsureVisible(LV_Console.Items.Count - 1) --Ensure the last entry is visible
		)
		on LV_Console ColumnWidthChanged arg do
		(
			try (LV_Console.columns.item[1].width = (parent.RO_ZorbConsole.width-10 - LV_Console.columns.item[0].width - LV_Console.columns.item[2].width - 25)) catch()
		)
		
		on CB_Enable changed arg do
		(
			if not arg then parent.AddLog #("User", "Log Disabled", 0)
			parent.enableLog = arg
			if arg then parent.AddLog #("User", "Log Enabled", 0)
		)
		on DD_Level selected arg do
		(
			parent.verboseLevel = arg - 1
			parent.AddLog #("User", ("Verbose Level changed to "+(parent.verboseLevel as string)), 0)
		)
		on ET_OrgFilter changed arg do
		(
			parent.OrgFilterStr = arg
			parent.fillOutLV LV_Console parent.LogData
		)
		on CK_OrgFilterInv changed arg do
		(
			parent.OrgFilterInv = arg
			parent.fillOutLV LV_Console parent.LogData
		)
		on CB_OrgFilterOn changed arg do
		(
			parent.OrgFilterOn = arg
			parent.fillOutLV LV_Console parent.LogData
		)
		on BT_Clear pressed do 
		(
			parent.ClearLog()
		)
	),

	fn closeMe = 
	(
		--AddLog #("User", "Log Closed", 0)
		this.RO_ZorbConsole.closeMe() -- get easy access to the close function
	),
	
	fn DateStamp=
	(
		MyTime = getlocaltime()
		MyTimeStr = ""
		for i = 1 to MyTime.count where i != 3 do
		(
			if i == 8 then 
			(
				if (MyTime[i] < 10) then append MyTimeStr ("00"+(MyTime[i] as string)) else
					if (MyTime[i] < 100) then append MyTimeStr ("0"+(MyTime[i] as string)) else
						append MyTimeStr (MyTime[i]  as string)
			)
			else if (MyTime[i] < 10) then append MyTimeStr ("0"+(MyTime[i] as string)) else append MyTimeStr (MyTime[i]  as string)
		)
		MyTimeStr
		--return (MyTimeStr as integer)
	),
	
	fn FormatDateStamp str noSeconds:false AmPm:false =
	(
		--str = timeNum as string
		if str.count != 17 then return false
		else
		(
			DateStr = stringstream ""
			theHour = ((str[9]+str[10]) as integer)
			if theHour > 11 then isPM = true else isPM = false
			if AmPm then (if isPM then theNewHour = ((theHour-12) as string) else theNewHour = theHour as string) else theNewHour = theHour as string
			if noSeconds then format "%%/%%/%%%% %:%%" str[7] str[8]  str[5] str[6] str[1] str[2] str[3] str[4]  theNewHour str[11] str[12] to:DateStr
				else format "%%/%%/%%%% %:%% %%.%%%s" str[7] str[8]  str[5] str[6] str[1] str[2] str[3] str[4]  theNewHour str[11] str[12] str[13] str[14] str[15] str[16] str[17] to:DateStr
			
			if AmPm then if isPM then format " PM" to:DateStr else format " AM" to:DateStr
			return (DateStr as string)
		)
	),

	fn fillOutLV lv arr=
	(
		lv.items.clear()
		theRange = #() --array to collect the list items
		addItem = false --if this flag is true item will be added to list view
		for i = 1 to arr.count do
		(
			addItem = false --reset flag
			if arr[i][3] <= this.verboseLevel then -- Filter by verbosity level
			(
				if this.OrgFilterOn then --use Origin Filter
				(
					addItem = (matchpattern arr[i][1] pattern:this.OrgFilterStr) == (not this.OrgFilterInv) --apply string filter and inverse if checked
				)
				else addItem = true
			)
			if additem then 
			(
				li = dotNetObject "System.Windows.Forms.ListViewItem" (arr[i][1] as string)
				case arr[i][3] of
				(
						5: li.foreColor=(dotNetClass "System.Drawing.Color").blue
						4: li.foreColor=(dotNetClass "System.Drawing.Color").green
						3: li.foreColor=(dotNetClass "System.Drawing.Color").orange
						2: li.foreColor=(dotNetClass "System.Drawing.Color").Darkred
						1: li.foreColor=(dotNetClass "System.Drawing.Color").Red
						0: li.foreColor=(dotNetClass "System.Drawing.Color").gray
				)
				sub_li = li.SubItems.add arr[i][2]
				sub_li = li.SubItems.add (FormatDateStamp arr[i][4] noSeconds:false AmPm:false)
				append theRange li --we add the list item to the array
			)
		)

		lv.Items.AddRange theRange --when done, we populate the ListView
		if lv.Items.Count != 0 then lv.EnsureVisible(lv.Items.Count - 1) --Ensure the last entry is visible
		return true
	),
	
	fn AddLog logArr =
	(
		if this.EnableLog then
		(
			if classof logArr == Array and logArr.count == 3 and classof logArr[1] == string and classof logArr[2] == string and classof logArr[3] == Integer  then
			(
				replacePrompt (logArr[1]+": "+logArr[2])
				--print logArr[3]
				append logArr (datestamp())  --Add datestamp to data
				append this.logData logArr
				if (hasproperty this.RO_ZorbConsole.LV_Console "items") then fillOutLV this.RO_ZorbConsole.LV_Console this.logData
			)
			else false
		)
		else false
	),
	
	fn ClearLog =
	(
		this.logData = #()
		this.AddLog #("User", "Log Cleared", 0)
		fillOutLV this.RO_ZorbConsole.LV_Console this.logData
	),
	
	fn updateUI =
	(
		this.RO_ZorbConsole.CB_Enable.checked = this.enableLog
		this.RO_ZorbConsole.DD_Level.selection = this.verboseLevel+1
		this.RO_ZorbConsole.ET_OrgFilter.text = this.OrgFilterStr
		this.RO_ZorbConsole.CK_OrgFilterInv.state =this.OrgFilterInv
		this.RO_ZorbConsole.CB_OrgFilterOn.checked = this.OrgFilterOn
	),
	
	fn ShowMe = 
	(
		if not this.RO_ZorbConsole.open then
		(
			try (destroydialog this.RO_ZorbConsole) catch ()
			createdialog this.RO_ZorbConsole 1200 272 style: #(#style_titlebar, #style_sysmenu, #style_resizing, #style_minimizebox)
			this.RO_ZorbConsole.parent = this
			--fillOutLV this.RO_ZorbConsole.LV_Console this.logData
			this.updateUI()
			AddLog #("User", "Log Opened", 0)
		)
		else
		(
			this.RO_ZorbConsole.placement =#minimized
			this.RO_ZorbConsole.placement =#normal
		)
	),
	
	ImHereToEndTheDeclerations = undefined

)
zc=ZorbConsole title:"Global"

MacroScript OpenGlobalZorbConsole
Category: "Zorb Tools"
toolTip:"Open Global Zorb Console"
Icon:#("Zorb-OpenGlobalConsole",1)
(
	if zc != undefined then zc.showMe()
)

/*
zc=ZorbConsole title:"Global" enableLog:true verboseLevel:3
zc.showMe()
zc.AddLog #("test", "I am testing-General", 0)
zc.AddLog #("test", "I am testing-Verbose", 5)
zc.AddLog #("test", "I am testing-Information", 4)
zc.AddLog #("test", "I am testing-Warning", 3)
zc.AddLog #("test", "I am testing-Error", 2)
zc.AddLog #("test", "I am testing1-Fatal Error", 1)

zc.AddLog #("test", "I am testing1", 0)
zc.RO_ZorbConsole.closeMe()
zc.closeMe()
*/